function curves=AddPoissonError(yi,M,dist1,factor1)

curves=[];

for real=1:M
    
    yirData=zeros(length(yi),1);
    
    yirData(1)=yi(1);
    
    if dist1==1
        %Poisson dist
        for t=2:length(yi)
            lambda=abs(yi(t)-yi(t-1));
            yirData(t,1)=poissrnd(lambda,1,1);
        end
        
    elseif dist1==2
        % Negative binomial dist
        for t=2:length(yi)
            lambda=abs(yi(t)-yi(t-1));
            mean1=lambda;
            var1=mean1*factor1;
            p1=mean1/var1;
            r1=mean1*p1/(1-p1);
            yirData(t,1)=nbinrnd(r1,p1,1,1);
        end
        
    end
    
    curves=[curves yirData];
end
