
function dx=modifiedLogisticGrowthPatch(t,x,r,p,a,K,npatches,onset_thr,q,flag1)

global invasions

dx=zeros(npatches,1);

switch flag1
    
    case 1 %GLM
        
        for j=1:npatches
            
            if invasions(j)==0
                
                invasions(j)=(x(j-1,1)>=onset_thr);
                
            end
            
            K1=K*exp(-q*(j-1)); 
            
            
            dx(j,1)=invasions(j).*(r*(x(j,1).^p)*(1-(x(j,1)/K1)));
            
            
        end
        
    case 2 %GRM
        
        for j=1:npatches
            
            if invasions(j)==0
                
                invasions(j)=(x(j-1,1)>=onset_thr);
                
            end
            
            
            K1=K*exp(-q*(j-1)); 
            
            dx(j,1)=invasions(j).*(r*(x(j,1).^p)*(1-(x(j,1)/K1)).^a);
            
            
        end
        
        
    case 3 %logistic
        
        for j=1:npatches
            
            if invasions(j)==0
                
                invasions(j)=(x(j-1,1)>=onset_thr);
                
            end
            
            
            K1=K*exp(-q*(j-1)); 
            
            
            dx(j,1)=invasions(j).*(r*(x(j,1))*(1-(x(j,1)/K1)));
            
        end
        
    case 4 %Richards
        
        for j=1:npatches
            
            if invasions(j)==0
                
                invasions(j)=(x(j-1,1)>=onset_thr);
                
            end
            
            
            K1=K*exp(-q*(j-1)); 
            
            
            
            dx(j,1)=invasions(j).*(r*(x(j,1))*(1-(x(j,1)/K1).^a));
            
            
        end
        
        
end


